/*
    This software may only be used by you under license from AT&T Corp.
    ("AT&T").  A copy of AT&T's Source Code Agreement is available at
    AT&T's Internet website having the URL:
    <http://www.research.att.com/sw/tools/graphviz/license/source.html>
    If you received this software without first entering into a license
    with AT&T, you have an infringing copy of this software and cannot use
    it without violating AT&T's intellectual property rights.
*/
#pragma prototyped

/*
 * Written by Stephen North and Eleftherios Koutsofios.
 */

#include	"dot.h"

int main(int argc, char** argv)
{
	graph_t	*g, *prev;

	prev = NIL(graph_t*);
	dot_initialize(argc,argv);
	while ((g = next_input_graph())) {
		if (prev) dot_close(prev);
		dot_init(g);
		dot_rank(g);
		dot_mincross(g);
		dot_position(g);
        dot_sameports(g);
		dot_splines(g);
		dot_postprocess(g);
		dot_write(g);
		prev = g;
	}
	dot_terminate();
	return 1;
}
