/*
    This software may only be used by you under license from AT&T Corp.
    ("AT&T").  A copy of AT&T's Source Code Agreement is available at
    AT&T's Internet website having the URL:
    <http://www.research.att.com/sw/tools/graphviz/license/source.html>
    If you received this software without first entering into a license
    with AT&T, you have an infringing copy of this software and cannot use
    it without violating AT&T's intellectual property rights.
*/

extern point		add_points(point, point);
extern int		allow_edits(int);
extern void		arrow_clip (edge_t *fe, edge_t *le, point *ps, int *startp, int *endp, bezier *spl);
extern double		atan2pt(point, point);
extern void		attach_attrs(Agraph_t *);
extern void		avoid_cycling(Agnode_t *, double *);
extern pointf		Bezier(pointf *, int, double, pointf *, pointf *);
extern shape_desc *bind_shape(char* name);
extern box		boxof(int, int, int, int);
extern char		*canoncolor(char *, char *);
extern void		cat_libfile(FILE *, char **, char **);
extern Agnode_t	*choose_node(void);
extern void		cleanup(Agraph_t *);
extern void		cleanup_edge(Agedge_t *);
extern void		cleanup_graph(Agraph_t *);
extern void		cleanup_node(Agnode_t *);
extern void		clip_and_install (edge_t *e, point *ps, int  pn);
extern point 		closest (splines *spl, point p);
extern int			clust_in_layer(Agraph_t *);
extern int			clust_in_layer(Agraph_t *);
extern int			codegen_bezier_has_arrows(void);
extern int			colorcmpf(void*, void*);
extern char		*colorxlate(char *, char *);
extern void		compute_bb(Agraph_t *);
extern point		coord(node_t *n);
extern int			csfnode(node_t* n);
extern pointf		cvt2ptf(point);
extern point		cvt2pt(pointf);
extern void		D2E(Agraph_t *, int, double (*)[2]);
extern node_t		*dequeue(void);
extern void		diffeq_model(void);
extern double		distvec(double *, double *, double *);
extern void		do_graph_label(Agraph_t *);
extern void		dot_postprocess(Agraph_t *);
extern void		dot_write(Agraph_t *);
extern int			edge_in_CB(Agedge_t *);
extern int			edge_in_CB(Agedge_t *);
extern int			edge_in_layer(Agraph_t *, Agedge_t *);
extern void		emit_attachment(textlabel_t *, splines *);
extern void		emit_background(Agraph_t *, point, point);
extern void		emit_clusters(Agraph_t *);
extern void		emit_defaults(graph_t* g);
extern void		emit_edge(Agedge_t *);
extern void		emit_edge(Agedge_t *);
extern void		emit_eof(void);
extern void		emit_graph(Agraph_t *, int sorted);
extern void		emit_header(Agraph_t *);
extern void		emit_label(textlabel_t *, graph_t *);
extern void		emit_layer(int);
extern void		emit_node(node_t *);
extern void		emit_node(node_t *);
extern void		emit_reset(Agraph_t *);
extern void		emit_trailer(void);
extern void		enqueue(node_t *);
extern void		epsf_define(void);
extern void		epsf_gencode(node_t *);
extern void		epsf_init(node_t *);
extern FILE		*file_select(char *);
extern void		final_energy(void);
extern shape_desc	*find_user_shape(char* name);
extern double		floatattr(void*, int, double);
extern double		fpow32(double);
extern void		free_array(double **, int, int);
extern void		free_queue(queue *);
extern void		free_splines(Agedge_t *);
extern void		getfloat(Agraph_t *, char *, double *);
extern void		getfloats2pt(Agraph_t *, char *, point *);
extern point	gif_textsize(char *str, char *fontname, double fontsz);
extern void		global_def(char *, Agsym_t *(*fun)(Agraph_t *, char *, char *));
extern void		heapdown(Agnode_t *);
extern void		heapup(Agnode_t *);
extern void		hsv2rgb(double *, double *, double *, double, double, double);
extern void		init_edge(Agedge_t *);
extern void		initialize(int, char **);
extern void		initial_positions(void);
extern void		init_node(Agnode_t *);
extern int			init_port(Agnode_t *, Agedge_t *, char *);
extern void		init_ugraph(Agraph_t *);
extern Agraph_t	*input_graph(void);
extern void		intr(int);
extern int			is_natural_number(char *);
extern void		jitter3d(Agnode_t *);
extern pointf		label_size(char *, textlabel_t *, graph_t *);
extern int			lang_select(char *);
extern int			late_attr(void*, char *);
extern double		late_float(void*, Agsym_t *, double, double);
extern int			late_int(void*, Agsym_t *, int, int);
extern char		*late_nnstring(void*, Agsym_t *, char *);
extern char		*late_string(void*, Agsym_t *, char *);
extern int			layerindex(char *);
extern int			layer_index(char *, int);
extern textlabel_t	*make_label(char *, double, char *, char *, graph_t *);
extern void		make_spring(Agnode_t *, Agnode_t *, double);
extern int			mapbool(char *);
extern void		map_edge(Agedge_t *);
extern point		map_point(point);
extern int			maptoken(char *, char **, int *);
extern void		Mcircle_hack(node_t* n);
extern box			mkbox(point, point);
extern void		Mlabel_hack(node_t* n);
extern void		move_node(Agnode_t *);
extern void		mysincos(double, double *, double *);
extern void		neato_write(Agraph_t *);
extern double		***new_3array(int, int, int, double);
extern double		**new_array(int, int, double);
extern queue		*new_queue(int);
extern FILE		*next_input_file(void);
extern Agraph_t	*next_input_graph(void);
extern int			node_in_CB(node_t *);
extern int			node_in_layer(Agraph_t *, node_t *);
extern void		nodesize(Agnode_t *, boolean);
extern void		osize_label(textlabel_t *, int *, int *, int *, int *);
extern point		pagecode(char);
extern point		pageincr(point);
extern int			parse_layers(char *);
extern char		**parse_style(char* s);
extern void		place_graph_label(Agraph_t *);
extern point		pointof(int, int);
extern void		printptf(FILE *, point);
extern void		prune(Agnode_t *, Agedge_t *);
extern void		randompos(Agnode_t *);
extern void		rec_attach_bb(Agraph_t *);
extern int			rect_overlap(box, box);
extern void		round_corners(point *, int, int);
extern int			round(double);
extern void		s1(node_t* node);
extern int			same_side(pointf, pointf, pointf, pointf);
extern void		scan_label_adjustments(Agraph_t *);
extern void		scan_graph(void);
extern int			selectedlayer(char *);
extern void		set_aspect(graph_t *g);
extern void		setup_graph(Agraph_t *);
extern void		setup_page(graph_t* g, point page);
extern void		shape_clip (node_t *n, point curve[4], edge_t *e);
extern void		shortest_path(void);
extern void		solve(double *, double *, double *, int);
extern void		solve_model(void);
extern point		spline_at_y(splines* spl, int y);
extern void		spline_edges(Agraph_t *);
extern int			strccnt(char *, char);
extern point		sub_points(point, point);
extern void		terminate(void);
extern void		toggle(int);
extern void		translate_bb(Agraph_t *, int);
extern void		translate_drawing(Agraph_t *);
extern node_t		*UF_find(node_t *);
extern node_t		*UF_union(node_t *u, node_t *v);
extern void		update_arrays(Agraph_t *, int);
extern void		use_library(char *);
extern char		*username(char *);
extern int			user_pos(Agsym_t *, Agnode_t *);
extern int			validpage(point);
extern void		write_plain(Agraph_t *, FILE*);
extern void*		zmalloc(size_t);
extern void*		zrealloc(void*, size_t, size_t, size_t);
